;
; Simple DLL start-up routine
; You should compile it with NASM
;

segment	TEXT32 use32 align=4 class=CODE flat
segment	DATA32 use32 align=4 class=DATA flat
segment	BSS32  use32 align=4 class=BSS flat

segment BSS32

		global	errno

thread_1:			; struct _thread
				; {
errno:		resd	1	;   int             _th_errno;
		resd	1	;   void          * _th_arg;
		resd	1	;   void          (*_th_start)(void *);
		resd	1	;   unsigned char * _th_strtok_ptr;
		resb	28	;   char            _th_asctime_buf[26+2];
		resb	16	;   char            _th_tmpnam_buf[16];
		resb	36	;   struct tm       _th_gmtime_buf;
		resd	1	;   unsigned int    _th_rand;
		resd	1	;   void          * _th_store;
		resd	1	;   int             _th_mblen_shift;
		resd	1	;   int             _th_mbtowc_shift;
		resd	1	;   int             _th_wctomb_shift;
		resb	12	;   char            _th_vollabel[12];
		resb	28	;   char            _th_error[28];
		resd	1	;   struct _uheap * _th_rheap;
		resd	1	;   struct _uheap * _th_theap;
		resb	32	;   char            _th_ttyname[32];
		resb	16	;   char            _th_inetntoa[16];
		resd	970	;   int             _th_reserved[971];
				; };
old_thread1:	resd	1	; Temporary storage for old pointer to this table

segment TEXT32

		extern	_thread

..start:	push	esi
		push	edi
		push	ebx

	; Check if the DLL is initializing
		cmp	dword [esp+20],0
		jne	.unload

	; First of all, check if we have the correct version of EMXLIBCM.DLL
	; We use a dirty hack to replace the address of errno for thread 0
		lea	eax,[_thread]
		cmp	word [eax+18],048Bh
		jne	.failed

	; Now get the address of the _thread_tab array
		mov	ecx,[eax+21]
	; Get the contents of _thread_tab[0] which
	; points to "struct _thread thread_1"
		mov	esi,[ecx+4]
		mov	[old_thread1],esi
	; ... and replace the _thread_tab[0] with our own array
		lea	edi,[thread_1]
		mov	[ecx+4],edi
	; Now copy the data from there to our storage
		mov	ecx,(4096/4)-1
		cld
		rep	movsd
	; Return a non-zero value to indicate success
.success:	mov	eax,1
		pop	ebx
		pop	edi
		pop	esi
		ret

.unload:	cmp	dword [esp+20],1
		jne	.failed

	; The library unloads. We have to restore the thread_1
	; table in the case the main executable will continue to run
	; after we're unloaded (otherwise it will raise a exception
	; as soon as EMXLIBCM will try to access the thread_1[0] table).
		lea	eax,[_thread]
		cmp	word [eax+18],048Bh
		jne	.failed

	; Now get the address of the _thread_tab array
		mov	ecx,[eax+21]
	; Get the contents of _thread_tab[0] which
	; points to "struct _thread thread_1"
		mov	esi,[ecx+4]
	; It should point to our table
		cmp	esi,thread_1
		jne	.failed
		mov	edi,[old_thread1]
		mov	[ecx+4],edi
	; Now copy the data from our table to old storage
		mov	ecx,(4096/4)-1
		cld
		rep	movsd
		jmp	.success

.failed:	xor	eax,eax
		pop	ebx
		pop	edi
		pop	esi
		ret
